#include "polinomi.h"
#include <stdio.h>
#include <stdlib.h>

polinomio *alloca_polinomio( int d ) {
	polinomio *res;

	res = (polinomio *)malloc( sizeof( polinomio ) );
	res->grado = d;
	res->coeff = (double *)calloc( d + 1, sizeof( double ) );
} 

polinomio *leggi_polinomio() {
	polinomio *res;
	int i, d;

	printf( "Grado? " );
	scanf( "%d", &d );
	res = alloca_polinomio( d );
	for ( i = 0; i <= d; i++ ) {
		printf( "\tCoefficiente di x^%d? ", i );
		scanf( "%lf", &res->coeff[ i ] );
	}
	return res;
}

void stampa_polinomio(polinomio *p, char variabile) {
	int i;

	for ( i = p->grado; i >= 0; i-- )
		if ( p->coeff[ i ] != 0.0 ) {
			if ( i < p->grado ) printf( "%+lf", p->coeff[ i ] );
			else printf( "%lf", p->coeff[ i ] );
			if ( i > 0 ) printf( " %c", variabile );
			if ( i > 1 ) printf( "^{%d}", i );
		}
	printf( "\n" );
}

polinomio *somma_polinomi(polinomio *p1, polinomio *p2) {
	polinomio *res;
	int d, i;
	
	d = ( p1->grado > p2->grado )? p1->grado : p2->grado;
	res = alloca_polinomio( d );
	for ( i = 0; i <= d; i++ )
		res->coeff[ i ] = p1->coeff[ i ] + p2->coeff[ i ];
	return res;
}

polinomio *prodotto_polinomi(polinomio *p1, polinomio *p2) {
	polinomio *res;
	int d, i, j;
	
	d = p1->grado + p2->grado;
	res = alloca_polinomio( d );
	for ( i = 0; i <= p1->grado; i++ )
		for ( j = 0; j <= p2->grado; j++ )
			res->coeff[ i + j ] += p1->coeff[ i ] * p2->coeff[ j ];
	return res;
}

double valuta_polinomio(polinomio *p, double x) {
	double res, v;
	int i;

	v = 1;
	for ( i = 0; i <= p->grado; i++ ) {
		res += p->coeff[ i ] * v;
		v *= x;
	}
	return res;
}

void libera_polinomio(polinomio *p) {
	free( p->coeff );
	free( p );
}
